
//#include "shapes.inc"
#include "colors.inc"
#include "metals.inc"

/*
light_source {<-5,5,4>, White }
light_source {<5,5,-5>, White }
light_source {<-2, 3, -5>, White }
light_source {<2, 3, -5>, White }


camera {
  location <0, 1, -7>
  look_at <0, 1, 0>
}
*/


// ** TEXTURES

#declare handle = texture
{
  pigment
  {
    gradient x
    color_map
    {
      [0.00 color rgb<0.000, 0.000, 0.000>]
      [0.50 color rgb<0.1, 0.1, 0.1>]
      [1.00 color rgb<0.000, 0.000, 0.000>]
    }
    scale <0.1667, 1.0, 1.0>
  }
  normal
  {
   bump_map
    {
      gif "C:\Gra\POVray\A&E\Hf1.gif"
      map_type 2
      bump_size 3.0
    }
    rotate <0.0, 0.0, 90.0>
  }
  finish {
    specular 0.11
    phong 0.41    phong_size 136
  }
}


#declare rolls = texture
{
  pigment
  {
    wood
    color_map
    {
      [0.00 color rgb<0.898, 0.910, 0.976>]
      [0.48 color rgb<0.918, 0.929, 0.976>]
      [1.00 color rgb<0.898, 0.910, 0.976>]
    }
  }
  normal {
    wood
    slope_map {
    [0.00 <.3, 0>]
    [0.19 <.3, 0>]
    [0.20 <.5, 0>]
    [0.70 <.5, 0>]
    [0.71 <.3, 0>]
    [1.00 <.3, 0>]
    }
  }
  finish {
    specular 0.2    roughness 0.24
  }
}



#declare cam = union { // camera object

// ** pod

union {
  cylinder {
    <0, -.15, 0>, <0, 0, 0>, .5
  }

  cylinder {
    <0, 0, 0>, <0, .1, 0>, .25
  }

  difference {
    union {
      cylinder {
        <0, -.15, 0>, <0, -5, 1.5>, .1
      }

      cylinder {
        <0, -.15, 0>, <-1.5, -5, -1>, .1
      }

       cylinder {
         <0, -.15, 0>, <1.5, -5, -1>, .1
       }
    } // end union

    box {
      <-2, -5, -2>, <2, -2, 2>
    }
  } // end difference

   difference {
    union {
      cylinder {
        <0, -.15, 0>, <0, -5, 1.5>, .07
      }

      cylinder {
        <0, -.15, 0>, <-1.5, -5, -1>, .07
      }

       cylinder {
         <0, -.15, 0>, <1.5, -5, -1>, .07
       }
     } // end union

    box {
      <-2, -5, -2>, <2, -3.5, 2>
    }
  } // end difference


   cylinder {
    <0, -.15, 0>, <0, -5, 1.5>, .05
  }

  cylinder {
    <0, -.15, 0>, <-1.5, -5, -1>, .05
  }

   cylinder {
     <0, -.15, 0>, <1.5, -5, -1>, .05
   }

  torus {
    .5, .05
    translate -y*1.5
    texture { T_Chrome_2E }
  }

texture { T_Chrome_1D }
} // end union


// ** camera

difference {
  box {
    <-1.5, .1, -.45>, <2, 1.5, .45>
  }

  cylinder {
    <2, .2, -.9>, <2, .2, .9>, .8
    scale <1, 1, 1>
  }

  box {
    <0, -.5, -.9>, <-1.7, .8, .9>
    rotate -z*25
    translate <-.9, -.65, 0>
  }
pigment { Gray30 }
finish { crand .2 specular .4}

} // end difference


// ** objectif

cylinder {
  <-1.5, 1, 0>, <-1.7, 1, 0>, .45
  pigment { Gray15 }
}

cylinder {
  <-1.7, 1, 0>, <-2.5, 1, 0>, .48
  texture { handle rotate z*90 scale <1, .8, 1> }
}

cylinder {
  <-2.5, 1, 0>, <-2.7, 1, 0>, .45
  pigment { Gray15 }
}

difference {
  cone {
    <-2.7, 1, 0>, .45
    <-3.2, 1, 0>, .65
  }

  cone {
    <-2.7, 1, 0>, .42
    <-3.21, 1, 0>, .62
  }
pigment { Gray20 }
} // end difference

// ** sucher

cylinder {
  <2, 1.25, 0>, <2.2, 1.25, 0>, .2
  pigment { Gray15 }
}

difference {
  cone {
    <2.2, 1.3, 0>, .2
    <2.4, 1.3, 0>, .35
    pigment { Gray15 }
  }

  cone {
    <2.2, 1.3, 0>, .19
    <2.41, 1.3, 0>, .33
    pigment { Gray15 }
  }
} // end difference


// ** film rolls

cylinder {
  <-.8, 2.4, -.2>, <-.8, 2.4, .2>, .9
  texture { rolls scale .5 translate <-.8, 2.4, 0> }
}

cylinder {
  <1, 2.4, -.2>, <1, 2.4, .2>, .9
  texture { rolls scale .5 translate <1, 2.4, 0>}
}

// ** handle

cylinder {
  <0, 1, -.45>, <0, 1, -.50>, .1
  texture { T_Chrome_3D }
}

difference {
  union {
    cylinder {
      <0, 1, -.65>, <1, 0, -.65>, .15
    }

    sphere {
      <0, 1, -.65>, .15
    }

    sphere {
      <1, 0, -.65>, .15
    }
  } // end union

  box {
    <-.5, 1.5, -.7>, <1.5, -.5, -1>
  }

  box {
    <-.5, 1.5, -.6>, <1.5, -.5, 0>
  }
translate z*.07
texture { T_Chrome_2D }
} // end difference

cylinder {
  <1, 0, -.65>, <1, 0, -1.2>, .1
  pigment { Black }
  finish {
    metallic
    reflection .2
    specular .6
  }
}

cylinder {
  <1, 0, -1.2>, <1, 0, -1.22>, .075
  texture { T_Chrome_4E }
}


//
rotate -y*75

} // end camera object union


//object { cam }




